diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
index d5f9ba5be..a10ef2547 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSheep.java
@@ -1,136 +1,104 @@
 package net.minecraft.client.render.entity;
 
-import com.mojang.logging.LogUtils;
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.animal.MobSheep;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.core.Global;
-import org.lwjgl.opengl.GL12;
-import org.slf4j.Logger;
+public class MobRendererSheep extends MobRenderer<MobSheep> {
 
-public class MobRendererSheep extends MobRenderer<MobSheep>
-{
-    private static final Logger LOGGER = LogUtils.getLogger();
-    public MobRendererSheep(ModelBase body, ModelBase wool, ModelBase overlay, float f)
-    {
-        super(body, f);
-        setArmorModel(wool);
-        setOverlayModel(overlay, "/assets/minecraft/textures/entity/sheep_overlay.png");
+    public MobRendererSheep(final float shadowSize) {
+        super(shadowSize);
     }
 
     @Override
-    public void render(Tessellator tessellator, MobSheep entity, double x, double y, double z, float yaw, float partialTick) {
-        GL11.glPushMatrix();
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        mainModel.swingProgress = getSwingProgress(entity, partialTick);
-        if (armorModel != null) armorModel.swingProgress = mainModel.swingProgress;
-        if (overlayModel != null) overlayModel.swingProgress = mainModel.swingProgress;
-        mainModel.isRiding = entity.isPassenger();
-        if (armorModel != null) armorModel.isRiding = mainModel.isRiding;
-        if (overlayModel != null) overlayModel.isRiding = mainModel.isRiding;
-        try
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSheep entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model;
+        switch (layer) {
+            case 1:
+                final int colorIndex = entity.getFleeceColor().blockMeta;
+                GL11.glColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][0], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][1], brightness * MobSheep.FLEECE_COLOR_TABLE[colorIndex][2]);
+                model = getModel("main");
+                bindTexture("/assets/minecraft/textures/entity/sheep/wool_overlay.png");
+                break;
+            case 2:
+                model = getModel("wool");
+                bindTexture("/assets/minecraft/textures/entity/sheep/wool_overlay.png");
+                break;
+            case 0:
+            default:
+                model = getModel("main");
+                break;
+        }
+        model.resetBones();
+
+        final BoneTransform head = model.getTransform("head");
+
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+
+        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
+        final float headBobTime = MathHelper.lerp(entity.prevTimeSheepEating, entity.timeSheepEating, partialTick);
+        // handles head rotation
+        if(entity.getIsSheepEating())
         {
-            float bodyYaw = entity.yBodyRotO + (entity.yBodyRot - entity.yBodyRotO) * partialTick;
-            float headYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
-            float headPitch = entity.xRotO + (entity.xRot - entity.xRotO) * partialTick;
-            translateModel(entity, x, y, z);
-            float limbSway = limbSway(entity, partialTick);
-            setupRotations(entity, limbSway, bodyYaw, partialTick);
-            float scale = 0.0625F;
-            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
-            GL11.glScalef(-1F, -1F, 1.0F);
-            setupScale(entity, partialTick);
-            GL11.glTranslatef(0.0F, -24F * scale - 0.0078125F, 0.0F);
-            float walkSpeed = entity.walkAnimSpeedO + (entity.walkAnimSpeed - entity.walkAnimSpeedO) * partialTick;
-            float walkProgress = entity.walkAnimPos - entity.walkAnimSpeed * (1.0F - partialTick);
-            if(walkSpeed > 1.0F)
+            // begin tilting head down
+            // Move head down
+            if (headBobTime < 5)
             {
-                walkSpeed = 1.0F;
+                final float partPercentage = headBobTime / 5;
+                head.rotX = -((headPitch * (1 - partPercentage)) + (60 * partPercentage)) * MathHelper.DEG_TO_RAD;
+                head.rotY = (headYaw * (1 - partPercentage)) * MathHelper.DEG_TO_RAD;
+
+                head.posY = -2.0f * (headBobTime);
             }
-            loadEntityTexture(entity);
-            GL11.glEnable(GL11.GL_ALPHA_TEST);
-            mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-            if (overlayModel != null)
+            // hold head in tilted position
+            // Hold head down and bob
+            else if (headBobTime < 35)
             {
-                bindTexture(overlayTexture);
-                overlayModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
+                head.rotX = -60 * MathHelper.DEG_TO_RAD;
+                head.rotY = 0;
+
+                head.posY = -10 + (MathHelper.sin((headBobTime * 0.05f) * 30.5f) / 3.0f);
             }
-            for(int renderPass = 0; renderPass < MAX_ARMOR_LAYERS; renderPass++)
+            // bring head up to normal rotation again
+            // Bring head back up
+            else if (headBobTime < 40)
             {
-                if(prepareArmor(entity, renderPass, partialTick))
-                {
-                    armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    GL11.glDisable(GL11.GL_BLEND);
-                    GL11.glEnable(GL11.GL_ALPHA_TEST);
-                }
-            }
+                final float partPercentage = (headBobTime - 35) / 5;
+                head.rotX = -((headPitch * partPercentage) + (60 * (1 - partPercentage))) * MathHelper.DEG_TO_RAD;
+                head.rotY = headYaw * partPercentage * MathHelper.DEG_TO_RAD;
 
-            renderAdditional(entity, partialTick);
-            float brightness = entity.getBrightness(partialTick);
-            if (Global.accessor.isFullbrightEnabled() || LightmapHelper.isLightmapEnabled()) brightness = 1.0f;
-            if(entity.hurtTime > 0 || entity.deathTime > 0)
-            {
-                GL11.glDisable(GL11.GL_TEXTURE_2D);
-                GL11.glDisable(GL11.GL_ALPHA_TEST);
-                GL11.glEnable(GL11.GL_BLEND);
-                GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-                GL11.glDepthFunc(514);
-                if(entity.hurtTime > 0 || entity.deathTime > 0)
-                {
-                    GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                    mainModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    if (overlayModel != null) overlayModel.render(null, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                    for(int k = 0; k < MAX_ARMOR_LAYERS; k++)
-                    {
-                        if(prepareArmor(entity, k, partialTick))
-                        {
-                            GL11.glColor4f(brightness, 0.0F, 0.0F, 0.4F);
-                            armorModel.render(entity, walkProgress, walkSpeed, limbSway, headYaw - bodyYaw, headPitch, scale, partialTick);
-                        }
-                    }
-                }
-                GL11.glDepthFunc(GL11.GL_LEQUAL);
-                GL11.glDisable(GL11.GL_BLEND);
-                GL11.glEnable(GL11.GL_ALPHA_TEST);
-                GL11.glEnable(GL11.GL_TEXTURE_2D);
+                head.posY = -10 + 2 * (headBobTime - 34);
             }
-            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         }
-        catch(Exception exception)
+        else
         {
-            LOGGER.error("Render exception in class '{}'!", getClass().getSimpleName(), exception);
+            // normal head rotations
+            head.rotX = headPitch * MathHelper.DEG_TO_RAD;
+            head.rotY = headYaw * MathHelper.DEG_TO_RAD;
         }
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glPopMatrix();
-        renderSpecials(tessellator, entity, x, y, z);
-    }
 
-    @Override
-    public void onUnload(){
-        overlayModel.onUnload();
+        return model;
     }
 
     @Override
-    protected boolean prepareArmor(MobSheep mobSheep, int renderPass, float partialTick)
-    {
-        if(renderPass == 0 && !mobSheep.getSheared())
-        {
-            bindTexture("/assets/minecraft/textures/entity/sheep_fur.png");
-            float brightness;
-            if(LightmapHelper.isLightmapEnabled() || Global.accessor.isFullbrightEnabled()) {
-                brightness = 1.0f;
-            }else {
-                brightness = mobSheep.getBrightness(partialTick);
-            }
-            int j = mobSheep.getFleeceColor().blockMeta;
-            GL11.glColor3f(brightness * MobSheep.FLEECE_COLOR_TABLE[j][0], brightness * MobSheep.FLEECE_COLOR_TABLE[j][1], brightness * MobSheep.FLEECE_COLOR_TABLE[j][2]);
-            return true;
-        } else
-        {
-            return false;
-        }
+    protected int maxRenderLayer(@NotNull final MobSheep entity) {
+        return entity.getSheared() ? 1 : 2;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSkeleton.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSkeleton.java
new file mode 100644
index 000000000..8c6d25613
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSkeleton.java
@@ -0,0 +1,48 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.core.entity.monster.MobSkeleton;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public class MobRendererSkeleton extends MobRendererBipedArmored<MobSkeleton>{
+
+    public MobRendererSkeleton(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel getActiveModel(@NotNull final MobSkeleton entity) {
+        return getModel("main");
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final MobSkeleton entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        if (model == null) return null;
+        final StaticEntityModel model1 = super.setupAnimations(entity, model, partialTick, layer);
+
+        final BoneTransform rightArm = model.getTransform("rightArm");
+        final BoneTransform leftArm = model.getTransform("leftArm");
+
+        final float limbPitch = getLimbPitch(entity, partialTick);
+        final float swingProgress = entity.getSwingProgress(partialTick);
+
+        final float var7 = MathHelper.sin(swingProgress * MathHelper.PI);
+        final float var8 = MathHelper.sin((1.0F - (1.0F - swingProgress) * (1.0F - swingProgress)) * MathHelper.PI);
+        rightArm.rotZ = 0.0F;
+        leftArm.rotZ = 0.0F;
+        rightArm.rotY = -(0.1F - var7 * 0.6F);
+        leftArm.rotY = 0.1F - var7 * 0.6F;
+        rightArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        leftArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        rightArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        leftArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        rightArm.rotZ += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        leftArm.rotZ -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        rightArm.rotX += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        leftArm.rotX -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        return model1;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
index bf97cf25d..7276fbd6a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
@@ -1,56 +1,40 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.core.entity.monster.MobSlime;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 public class MobRendererSlime extends MobRenderer<MobSlime>
 {
 
-    public MobRendererSlime(ModelBase modelbase, ModelBase modelbase1, float f)
-    {
-        super(modelbase, f);
-        scaleAmount = modelbase1;
+    public MobRendererSlime(final float shadowSize) {
+        super(shadowSize);
     }
 
-    protected boolean renderSlimePassModel(MobSlime entity, int i, float f)
-    {
-        if(i == 0)
-        {
-            setArmorModel(scaleAmount);
-            GL11.glEnable(2977 /*GL_NORMALIZE*/);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            return true;
-        }
-        if(i == 1)
-        {
-            GL11.glDisable(GL11.GL_BLEND);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        }
-        return false;
-    }
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSlime entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        GL11.glEnable(GL12.GL_NORMALIZE);
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
 
-    protected void scaleSlime(MobSlime entityslime, float f)
-    {
-        int i = entityslime.getSlimeSize();
-        float f1 = (entityslime.oSquish + (entityslime.squish - entityslime.oSquish) * f) / ((float)i * 0.5F + 1.0F);
-        float f2 = 1.0F / (f1 + 1.0F);
-        float f3 = i;
-        GL11.glScalef(f2 * f3, (1.0F / f2) * f3, f2 * f3);
-    }
+        model.resetBones();
 
-    @Override
-    protected void setupScale(MobSlime entity, float partialTick)
-    {
-        scaleSlime(entity, partialTick);
-    }
+        final int slimeSize = entity.getSlimeSize();
+        final float squishStrength = (MathHelper.lerp(entity.oSquish, entity.squish, partialTick)) / (slimeSize * 0.5F + 1.0F);
+        final float scale = 1.0F / (squishStrength + 1.0F);
 
-    @Override
-    protected boolean prepareArmor(MobSlime entity, int renderPass, float partialTick)
-    {
-        return renderSlimePassModel(entity, renderPass, partialTick);
-    }
+        final BoneTransform cube = model.getTransform("cube");
 
-    private final ModelBase scaleAmount;
+        cube.scaleX = scale * slimeSize;
+        cube.scaleY = (1.0F / scale) * slimeSize;
+        cube.scaleZ = scale * slimeSize;
+
+        return model;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSnowman.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSnowman.java
new file mode 100644
index 000000000..f6b55c18a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSnowman.java
@@ -0,0 +1,48 @@
+package net.minecraft.client.render.entity;
+
+import net.minecraft.core.entity.monster.MobSnowman;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public class MobRendererSnowman extends MobRendererBiped<MobSnowman>{
+
+    public MobRendererSnowman(final float shadowSize) {
+        super(shadowSize);
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel getActiveModel(@NotNull final MobSnowman entity) {
+        return getModel("main");
+    }
+
+    @Override
+    protected @Nullable StaticEntityModel setupAnimations(@NotNull final MobSnowman entity, @Nullable final StaticEntityModel model, final float partialTick, final int layer) {
+        if (model == null) return null;
+        final StaticEntityModel model1 = super.setupAnimations(entity, model, partialTick, layer);
+
+        final BoneTransform rightArm = model.getTransform("rightArm");
+        final BoneTransform leftArm = model.getTransform("leftArm");
+
+        final float limbPitch = getLimbPitch(entity, partialTick);
+        final float swingProgress = entity.getSwingProgress(partialTick);
+
+        final float var7 = MathHelper.sin(swingProgress * MathHelper.PI);
+        final float var8 = MathHelper.sin((1.0F - (1.0F - swingProgress) * (1.0F - swingProgress)) * MathHelper.PI);
+        rightArm.rotZ = 0.0F;
+        leftArm.rotZ = 0.0F;
+        rightArm.rotY = -(0.1F - var7 * 0.6F);
+        leftArm.rotY = 0.1F - var7 * 0.6F;
+        rightArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        leftArm.rotX = -90 * MathHelper.DEG_TO_RAD;
+        rightArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        leftArm.rotX -= var7 * 1.2F - var8 * 0.4F;
+        rightArm.rotZ += MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        leftArm.rotZ -= MathHelper.cos(limbPitch * 0.09F) * 0.05F + 0.05F;
+        rightArm.rotX += MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        leftArm.rotX -= MathHelper.sin(limbPitch * 0.067F) * 0.05F;
+        return model1;
+    }
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
index 45b6bff3a..64a370322 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
@@ -1,46 +1,106 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.model.ModelSpider;
 import net.minecraft.core.entity.monster.MobSpider;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererSpider extends MobRenderer<MobSpider>
-{
+public class MobRendererSpider extends MobRenderer<MobSpider> {
 
-    public MobRendererSpider()
-    {
-        super(new ModelSpider(0), 1.0F);
-        setArmorModel(new ModelSpider(0.01f));
+    public MobRendererSpider(final float shadowSize) {
+        super(shadowSize);
     }
-    protected boolean setSpiderEyeBrightness(MobSpider spider, int renderPass, float partialTick)
-    {
-        if(renderPass == 0)
-        {
-            bindTexture("/assets/minecraft/textures/entity/spider/eyes/" + spider.getTextureReference() + ".png");
-            float brightness = spider.getBrightness(1.0f);
-            if(LightmapHelper.isLightmapEnabled()) {
-                LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
-            }
-            float f1 = (1.0F - brightness) * 0.5F;
+
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSpider entity, final float brightness, final float partialTick, final int layer) {
+        if (layer == 1) {
+            bindTexture("/assets/minecraft/textures/entity/spider/eyes/" + entity.getTextureReference() + ".png");
+            if(LightmapHelper.isLightmapEnabled()) LightmapHelper.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(15));
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, f1);
-            return true;
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, (1.0F - entity.getBrightness(partialTick)) * 0.5F);
         }
 
-        return false;
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+
+
+        final BoneTransform head = model.getTransform("head");
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+        final BoneTransform leg4 = model.getTransform("leg4");
+        final BoneTransform leg5 = model.getTransform("leg5");
+        final BoneTransform leg6 = model.getTransform("leg6");
+        final BoneTransform leg7 = model.getTransform("leg7");
+
+        head.rotX = headPitch;
+        head.rotY = headYaw;
+
+        final double rZ = 45 * MathHelper.DEG_TO_RAD;
+        leg0.rotZ = -rZ;
+        leg1.rotZ =  rZ;
+        leg2.rotZ = -rZ * 0.74F;
+        leg3.rotZ =  rZ * 0.74F;
+        leg4.rotZ = -rZ * 0.74F;
+        leg5.rotZ =  rZ * 0.74F;
+        leg6.rotZ = -rZ;
+        leg7.rotZ =  rZ;
+        final double ry = 22.5 * MathHelper.DEG_TO_RAD;
+        leg0.rotY =  ry * 2.0F;
+        leg1.rotY = -ry * 2.0F;
+        leg2.rotY =  ry;
+        leg3.rotY = -ry;
+        leg4.rotY = -ry;
+        leg5.rotY =  ry;
+        leg6.rotY = -ry * 2.0;
+        leg7.rotY =  ry * 2.0F;
+        final double pair1Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + 0.0F) * 0.4F) * limbYaw;
+        final double pair2Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI) * 0.4F) * limbYaw;
+        final double pair3Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
+        final double pair4Y = -(MathHelper.cos(limbSwing * 0.6662F * 2.0F + MathHelper.PI * 1.5F) * 0.4F) * limbYaw;
+        final double pair1Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + 0.0F) * 0.4F) * limbYaw;
+        final double pair2Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + MathHelper.PI) * 0.4F) * limbYaw;
+        final double pair3Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + MathHelper.PI / 2F) * 0.4F) * limbYaw;
+        final double pair4Z = Math.abs(MathHelper.sin(limbSwing * 0.6662F + MathHelper.PI * 1.5F) * 0.4F) * limbYaw;
+        leg0.rotY += pair1Y;
+        leg1.rotY -= pair1Y;
+        leg2.rotY += pair2Y;
+        leg3.rotY -= pair2Y;
+        leg4.rotY += pair3Y;
+        leg5.rotY -= pair3Y;
+        leg6.rotY += pair4Y;
+        leg7.rotY -= pair4Y;
+        leg0.rotZ += pair1Z;
+        leg1.rotZ -= pair1Z;
+        leg2.rotZ += pair2Z;
+        leg3.rotZ -= pair2Z;
+        leg4.rotZ += pair3Z;
+        leg5.rotZ -= pair3Z;
+        leg6.rotZ += pair4Z;
+        leg7.rotZ -= pair4Z;
+        return model;
     }
 
     @Override
-    protected float getMaxDeathRotation(MobSpider entity)
-    {
-        return 180f;
+    protected float getMaxDeathRotation(@NotNull final MobSpider entity) {
+        return 180;
     }
 
     @Override
-    protected boolean prepareArmor(MobSpider entity, int renderPass, float partialTick) {
-        return setSpiderEyeBrightness(entity, renderPass, partialTick);
+    protected int maxRenderLayer(@NotNull final MobSpider entity) {
+        return 1;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java
index 10b6e5dfe..ddd6858d4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSquid.java
@@ -1,40 +1,61 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.animal.MobSquid;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererSquid extends MobRenderer<MobSquid>
-{
-    public MobRendererSquid(ModelBase modelbase, float f)
-    {
-        super(modelbase, f);
+public class MobRendererSquid extends MobRenderer<MobSquid> {
+
+    public MobRendererSquid(final float shadowSize) {
+        super(shadowSize);
     }
+
     @Override
-    protected float limbSway(MobSquid squid, float partialTick)
-    {
-        return squid.oldTentacleAngle + (squid.tentacleAngle - squid.oldTentacleAngle) * partialTick;
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSquid entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final float limbPitch = getLimbPitch(entity, partialTick);
+        model.getTransform("tentacle1").rotX = limbPitch;
+        model.getTransform("tentacle2").rotX = limbPitch;
+        model.getTransform("tentacle3").rotX = limbPitch;
+        model.getTransform("tentacle4").rotX = limbPitch;
+        model.getTransform("tentacle5").rotX = limbPitch;
+        model.getTransform("tentacle6").rotX = limbPitch;
+        model.getTransform("tentacle7").rotX = limbPitch;
+        model.getTransform("tentacle8").rotX = limbPitch;
+
+        return model;
     }
 
     @Override
-    protected void setupRotations(MobSquid squid, float ticksExisted, float bodyYaw, float partialTick)
+    protected float getLimbPitch(final @NotNull MobSquid squid, final float partialTick)
     {
-        if (squid.isSpecial()) {
-            super.setupRotations(squid, ticksExisted, bodyYaw, partialTick);
+        return MathHelper.lerp(squid.oldTentacleAngle, squid.tentacleAngle, partialTick);
+    }
+
+    @Override
+    protected void preRenderTransform(@NotNull final MobSquid entity, final double x, final double y, final double z, final float _yaw, final float partialTick) {
+        if (entity.isSpecial()) {
+            GL11.glTranslated(0, 1.5, 0);
+            super.preRenderTransform(entity, x, y, z, _yaw, partialTick);
         } else {
-            float pitch = squid.xBodyRotO + (squid.xBodyRot - squid.xBodyRotO) * partialTick;
-            float yaw = squid.zBodyRotO + (squid.zBodyRot - squid.zBodyRotO) * partialTick;
-            GL11.glTranslatef(0.0F, 0.5F, 0.0F);
-            GL11.glRotatef(180F - bodyYaw, 0.0F, 1.0F, 0.0F);
+            GL11.glTranslated(x, y + 0.5, z);
+            GL11.glScalef(1/ MobRenderer.ENTITY_RENDER_SCALE, 1/ MobRenderer.ENTITY_RENDER_SCALE, 1/ MobRenderer.ENTITY_RENDER_SCALE);
+            final float pitch = entity.xBodyRotO + (entity.xBodyRot - entity.xBodyRotO) * partialTick;
+            final float yaw = entity.zBodyRotO + (entity.zBodyRot - entity.zBodyRotO) * partialTick;
+            GL11.glRotatef(180 - getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0.0F, 1.0F, 0.0F);
             GL11.glRotatef(pitch, 1.0F, 0.0F, 0.0F);
             GL11.glRotatef(yaw, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -1.2F, 0.0F);
         }
     }
 
     @Override
-    public void renderPreview(Tessellator tessellator, MobSquid squid, double x, double y, double z, float yaw, float partialTick) {
+    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobSquid squid, final double x, final double y, final double z, final float yaw, final float partialTick) {
         GL11.glPushMatrix();
         GL11.glTranslatef(0.0f, 1.25f, 0.0f);
         super.renderPreview(tessellator,squid, x, y, z, yaw, partialTick);
